import os

from cpl_core.configuration import ConfigurationABC
from cpl_core.dependency_injection import ServiceCollectionABC
from cpl_core.environment import ApplicationEnvironmentABC
from cpl_discord.service.discord_collection_abc import DiscordCollectionABC

from bot_core.abc.module_abc import ModuleABC
from bot_core.configuration.feature_flags_enum import FeatureFlagsEnum
from modules.level.level_seeder import LevelSeeder


class LevelModule(ModuleABC):

    def __init__(self, dc: DiscordCollectionABC):
        ModuleABC.__init__(self, dc, FeatureFlagsEnum.level_module)

    def configure_configuration(self, config: ConfigurationABC, env: ApplicationEnvironmentABC):
        cwd = env.working_directory
        env.set_working_directory(os.path.dirname(os.path.realpath(__file__)))
        config.add_json_file(f'default-level.json', optional=False)
        env.set_working_directory(cwd)

    def configure_services(self, services: ServiceCollectionABC, env: ApplicationEnvironmentABC):
        services.add_transient(LevelSeeder)
